#!/usr/bin/perl
# $Id: admin.cgi,v 1.48 2003/05/15 19:21:39 jzawacki Exp $

use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);
use DB_File;
use email_common;
use HTMLTMPL;
require 'setup.pl';

my $cgi = CGI->new();

# ****** SET THESE VARIABLES *******
my ($dir_URL, $db_path, $img_URL) = Set_location;
my ($time_off_from_NY) = Server_time;

# Command Definitions

my $param_cmd = "command";
my $param_email_id = "email_ID";
my $param_sid = "SID";

# User related commands

my $cmd_save_style_settings = "Update Style Settings";
my $cmd_save_system_config = "Update Sys Config";

my $cmd_show_dir_list = "showdirlist";

my $cmd_show_dir = "showdir";
my $param_dir_name = "directory";

my $cmd_show_file = "showfile";
my $param_file_name = "file";

my $cmd_delete_user = "deletedir";
my $param_user_name = "username";

my $cmd_sysconfig = "sysconfig";

my $cmd_sysstyle = "sysstyle";
my $cmd_showcolors = "showcolors";

my $cmd_deletealiases = "deletealiases";

# Configuration related commands

my $cmd_user_info = "userinfo";
my $cmd_user_update_quota = "updatequota";
my $param_new_quota = "newQuota";
my $cmd_user_change_password = "change_password";
my $param_new_password = "newPassword";
my $cmd_edit_welcome = "editwelcome";
my $cmd_preview_welcome = "previewwelcome";
my $cmd_save_welcome = "savewelcome";
my $param_to = "to";
my $param_from = "from";
my $param_subject = "subject";
my $param_date = "date";
my $param_content_type = "content_type";
my $param_xmailer = "xmailer";
my $param_body = "body";
my $cmd_edit_quotamsg = "editquotamsg";
my $cmd_preview_quotamsg = "previewquotamsg";
my $cmd_save_quotamsg = "savequotamsg";
my $cmd_edit_aliases = "editaliases";
my $cmd_save_aliases = "savealiases";

# Start of script

my $cmd_default = $cmd_show_dir_list;

my $email_ID = $cgi->param($param_email_id);
my $SID = $cgi->param($param_sid);
my $command = $cgi->param($param_cmd);

Check_session($email_ID,$SID);

my $base_url = "admin.cgi?email_ID=$email_ID&SID=$SID";

my %cmd_map = (	$cmd_show_file       => \&showfiledata,
		$cmd_show_dir        => \&showfiles,
		$cmd_show_dir_list   => \&showdirlist,
		$cmd_delete_user     => \&deleteaccounts,
		$cmd_edit_welcome    => \&editwelcome,
		$cmd_preview_welcome => \&previewwelcome,
		$cmd_save_welcome    => \&savewelcome,
                $cmd_sysconfig       => \&sysconfig,
		$cmd_save_system_config => \&save_system_config,
                $cmd_sysstyle        => \&sysstyle,
		$cmd_save_style_settings => \&save_style_settings,
                $cmd_showcolors      => \&showcolors,
		$cmd_user_info	     => \&userinfo,
		$cmd_user_update_quota => \&userinfo_updatequota,
		$cmd_user_change_password => \&userinfo_changepassword,
                $cmd_edit_quotamsg       => \&editquotamsg,
                $cmd_preview_quotamsg    => \&previewquotamsg,
                $cmd_save_quotamsg       => \&savequotamsg,
		$cmd_edit_aliases    => \&editaliases,
    		$cmd_deletealiases => \&deletealiases,
                $cmd_save_aliases    => \&savealiases,
	);

eval { &main; } or cgierr ("fatal undef error: $@", 1); 

sub main {
    my $routine;
    if (defined $cmd_map{$command}) {
	$routine = $cmd_map{$command};
    } else {
	$routine = $cmd_map{$cmd_default};
    }
    &$routine();
}

# User related activities

sub showdirlist {
    my $target = $::Temp_Directory;
    my $quota_limit;
    my %User_info;
    my $QPercent;
    my $QPcolor; #Font color for quota display

    print <<EOP;
Content-type: text/html

<HTML><BODY>
  <form method='POST' ACTION='admin.cgi'>
    <input type='hidden' name='$param_email_id' value='$email_ID'>
    <input type='hidden' name='$param_sid' value='$SID'>
    <input type='hidden' name='$param_cmd' value='$cmd_delete_user'>
    <table width='100%' cellpadding=3 cellspacing=1>
      <tr bgcolor=#A0B8C8>
        <td><b>$target</b></td>
      </tr>
    </table>
    <table width="100%" cellspacing="1" cellpadding="3" border="0">
      <tr bgcolor="#AADDDD">
        <td width="10">&nbsp;</td>
        <td width="20">Del</td>
        <td width="200">Username</td>
        <td width="250">Last Login</td>
        <td width="50">Messages</td>
        <td width="150">Quota</td>
        <td width="70">Size</td>
      </tr>
EOP

    opendir(IMD, $target) || cgierr("Cannot open directory $target");
    my @thefiles= sort readdir(IMD);
    closedir(IMD);

    my $xcount = 0;
    my $line;
    my $dir_size;
    my $time_offset = Check_session($email_ID,$SID);
    my $dir_time;
    my $junk;
    foreach my $f (@thefiles) {
	unless ( ($f eq ".") || ($f eq "..") || ($f eq "999999") ||
		 ($f eq "folders.start") || ($f eq "findprob") ||
                 ($f eq "999998") || ($f eq "alias_info") || 
                 ($f eq "address_book")) { 
	    ++$xcount;
###  Quota Check ###
dbmopen(%User_info,"$target/$f/user_info",0660) || die "Could not open $target/$
f/user_info.db $!";
$quota_limit = $User_info{'17Quota_limit'};

if ($quota_limit < 1) {
$quota_limit = $::Quota_Default;
}
($dir_size, $QPercent) = &Check_quota($quota_limit,$f);
$QPcolor = "black";
if ($QPercent > 100) {
$QPcolor = "red";
}
$QPercent .= "%";
dbmclose %User_info || die "Could not close HASH. $!";

### End Quota Check ###

            $dir_time = $^T - int((-M "$target/$f") * 3600*24);

	    open(DIR, "du -sk $target/$f|") || cgierr("Can't open $target/$f");
	    $line = <DIR>;
	    ($dir_size, $junk) = split /\s/, $line;
	    close(DIR);
	    $dir_size .= " kb";
      my $messagelist = "$target/$f";
     opendir(IMD, $messagelist) || cgierr("Cannot open directory $messagelist");
     my @themessages = readdir(IMD);
     closedir(IMD);

     my $mcount  = 0;
     foreach my $m (@themessages) {
        unless ( ($m eq ".") || ($m eq "..") || ($m eq "folders") ||
                 ($m eq "address_book") || ($m eq "pass") ||
                 ($m eq "user_info") || ($m eq "sessID") ||
                 ($m eq "uploads") || ($m eq "folders.undo2") ||
                 ($m eq "folders.undo3")){
            ++$mcount;
              }
            }
	    print <<EOP;
    <tr>
        <td>$xcount</td>
        <td><INPUT TYPE='checkbox' NAME='username' VALUE='$f'></td>
        <td><a href='$base_url&$param_cmd=$cmd_user_info&$param_user_name=$f'>$f</a></td>
EOP
print "<td>",scalar(localtime($dir_time + $time_offset)),"</td>";
print <<EOP;
    <td align=right>$mcount</td>
    <td align=right><font color=$QPcolor>$QPercent</font></td>
    <td align=right>$dir_size</td>
  </tr>
EOP
	}
    }
    print <<EOP;
      <tr>
        <td colspan=6 align=center><input type=submit value='Submit'></td>
      </tr>
    </table>
  </form>
</BODY></HTML>
EOP
}

sub showfiles {
    my $showingdir = $cgi->param($param_dir_name);
    my $target = "$::Temp_Directory/$showingdir";

    print <<EOP;
Content-type: text/html

<HTML><BODY>
  <table width='100%' cellpadding=3 cellspacing=1>
    <tr bgcolor=#A0B8C8>
      <td><b>$target</b></td>
      <td align=right><a href = 'javascript:history.back()'>Back</a></td>
    </tr>
  </table>
  <table width="100%" cellspacing="1" cellpadding="3" border="0">
    <tr bgcolor="#AADDDD">
      <td width="1%">&nbsp;</td>
      <td width="15%">File Name</td>
      <td width="20%">Date Created</td>
      <td width="2%">Size</td>
    </tr>
EOP

    opendir(IMD, $target) || die("Cannot open directory");
    my @thefiles= sort readdir(IMD);
    closedir(IMD);

    my $filecount = 0;
    my $filesize = 0;
    my $time_offset = Check_session($email_ID,$SID);
    my $file_time;
    foreach my $f (@thefiles)
    {
      unless ( ($f eq ".") || ($f eq "..") || ($f eq "uploads") ||
               ($f eq "pass") || ($f eq "folders") || ($f eq "999999") ||
               ($f eq "address_book") || ($f eq "user_info") ||
               ($f eq "sessID"))
      { 
	++$filecount;
	$filesize = (-s "$target/$f");
        $file_time = $^T - int((-M "$target/$f") * 3600*24);
	print <<EOP;
    <tr>
      <td>$filecount</td>
      <td><a href='$base_url&$param_cmd=$cmd_show_file&$param_dir_name=$showingdir&$param_file_name=$f'>$f</a></td>
EOP
print "<td>",scalar(localtime($file_time + $time_offset)),"</td>";
print "<td align=right>$filesize</td></tr>";
      }
    }
    print <<EOP;
    <tr>
      <td>&nbsp</td>
      <td>&nbsp</td>
    </tr>
  </table>
</BODY></HTML>
EOP
}

sub showfiledata {
    my $showingfile = $cgi->param($param_file_name);
    my $showingdir = $cgi->param($param_dir_name);
    my $target = "$::Temp_Directory/$showingdir/$showingfile";

    print <<EOP;
Content-type: text/html

<HTML><BODY>
  <table width='100%' cellpadding=3 cellspacing=1>
    <tr bgcolor=#A0B8C8>
      <td><b>$target</b></td>
      <td align=right><a href = 'javascript:history.back()'>Back</a></td>
    </tr>
  </table>
  <table width='100%' cellspacing='1' cellpadding='3' border='0'>
  <tr><td>
EOP

    my $line;
    open(OUTF, "$target");
    while ($line = <OUTF>) {
	print "$line<br>\n";
    }
    close(OUTF);
    print "</td></tr></table></BODY></HTML>";
}

sub deleteaccounts {
    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_deleteaccounts.html");
    $result->TITLE("Delete User Results");
    $result->BACKGROUND("white");
    $result->new_url("$dir_URL/$base_url");
    my @deleteusers = $cgi->param($param_user_name);

    foreach my $user (@deleteusers) {
      my $target = "$::Temp_Directory/$user";

      system("rm","-fr","$target");

      $result->user_name($user, 'x_user_details');
      $result->user_directory($target, 'x_user_details');
    }
    $result->output('Content-Type: text/html');
}

# Configuration Related activities.
sub editwelcome {
    my $file = "$db_path/999999";
    my @contents;
    my ($line, $to, $from, $subject, $date, $content_type, $xmailer, $body);

    open(MSG, $file) or cgierr("Unable to open the welcome message($file).");
    while(($line = <MSG>) && ($line ne "\n")) {
        chomp $line;
	if ($line =~ /^[Tt][Oo]:\s*(.*)$/) {
	    $to = $1;
	} elsif ($line =~ /^[Ff][Rr][Oo][Mm]:\s*(.*)$/) {
	    $from = $1;
	} elsif ($line =~ /^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:\s*(.*)$/) {
	    $subject = $1;
	} elsif ($line =~ /^[Dd][Aa][Tt][Ee]:\s*(.*)$/) {
	    $date = $1;
	} elsif ($line =~ /^[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]:\s*(.*)$/) {
	    $content_type = $1;
	} elsif ($line =~ /^[Xx]-[Mm][Aa][Ii][Ll][Ee][Rr]:\s*(.*)$/) {
	    $xmailer = $1;
	}
    }
    @contents = <MSG>;
    close(MSG);

    foreach (@contents) {
	$body .= $_;
    }

    # Create the template object and load it.
    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_editwelcome.html");
    $result->TITLE("Edit Welcome Message");
    $result->BACKGROUND("white");
    $result->email_ID($email_ID);
    $result->SID($SID);
    $result->to($to);
    $result->from($from);
    $result->subject($subject);
    $result->content_type($content_type);
    $result->date($date);
    $result->xmailer($xmailer);
    $result->message_text($body);
    $result->output('Content-Type: text/html');
}

sub escape_html {
    $_ = shift;

    s/\n/<br>\n/g;
    s/</&lt;/g;
    s/>/&gt;/g;

    return $_;
}

sub previewwelcome {
    my $to = $cgi->param($param_to);
    my $from = $cgi->param($param_from);
    my $subject = $cgi->param($param_subject);
    my $date = $cgi->param($param_date);
    my $content_type = $cgi->param($param_content_type);
    my $xmailer = $cgi->param($param_xmailer);
    my $body = $cgi->param($param_body);

    $_ = $body;
    s/\n/<br>\n/g;
    my $message_html = $_;

    # Create the template object and load it.
    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_previewwelcome.html");
    $result->TITLE("Preview Welcome Message");
    $result->BACKGROUND("white");
    $result->to($to);
    $result->from($from);
    $result->subject($subject);
    $result->content_type($content_type);
    $result->date($date);
    $result->xmailer($xmailer);
    $result->message_text($body);
    $result->to_html(escape_html($to));
    $result->from_html(escape_html($from));
    $result->subject_html(escape_html($subject));
    $result->content_type_html(escape_html($content_type));
    $result->date_html(escape_html($date));
    $result->xmailer_html(escape_html($xmailer));
    $result->message_html($message_html);
    $result->email_ID($email_ID);
    $result->SID($SID);
    $result->output('Content-Type: text/html');
}

sub savewelcome {
    my $file = "$db_path/999999";
    my $to = $cgi->param($param_to);
    my $from = $cgi->param($param_from);
    my $subject = $cgi->param($param_subject);
    my $date = $cgi->param($param_date);
    my $content_type = $cgi->param($param_content_type);
    my $xmailer = $cgi->param($param_xmailer);
    my $body = $cgi->param($param_body);

    open(MSG, ">$file") or cgierr("Unable to open the welcome message($file) for writing.");
    print MSG "To: $to\n";
    print MSG "From: $from\n";
    print MSG "Subject: $subject\n";
    print MSG "Date: $date\n";
    print MSG "Content-type: $content_type\n";
    print MSG "X-Mailer: $xmailer\n";
    print MSG "\n";
    print MSG "$body";
    close(MSG);

    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_savewelcome.html");
    $result->TITLE("Save Welcome Result");
    $result->BACKGROUND("white");
    $result->destination_url("$dir_URL/$base_url");
    $result->output('Content-Type: text/html');
}

sub editquotamsg {
    my $file = "$db_path/999998";
    my @contents;
    my ($line, $from, $subject, $content_type, $xmailer, $body);

    open(MSG, $file) or cgierr("Unable to open quota message($file).");
    while(($line = <MSG>) && ($line ne "\n")) {
        chomp $line;
        if ($line =~ /^[Ff][Rr][Oo][Mm]:\s*(.*)$/) {
            $from = $1;
        } elsif ($line =~ /^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]:\s*(.*)$/) {
            $subject = $1;
        } elsif ($line =~ /^[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]:\s*(.*
)$/) {
            $content_type = $1;
        } elsif ($line =~ /^[Xx]-[Mm][Aa][Ii][Ll][Ee][Rr]:\s*(.*)$/) {
            $xmailer = $1;
        }
    }
    @contents = <MSG>;
    close(MSG);

    foreach (@contents) {
        $body .= $_;
    }

    # Create the template object and load it.
    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_editquotamsg.html");
    $result->TITLE("Edit Quota Message");
    $result->BACKGROUND("white");
    $result->email_ID($email_ID);
    $result->SID($SID);
#    $result->to($to);
    $result->from($from);
    $result->subject($subject);
    $result->content_type($content_type);
#    $result->date($date);
    $result->xmailer($xmailer);
    $result->message_text($body);
    $result->output('Content-Type: text/html');
}

sub previewquotamsg {
    my $from = $cgi->param($param_from);
    my $subject = $cgi->param($param_subject);
    my $content_type = $cgi->param($param_content_type);
    my $xmailer = $cgi->param($param_xmailer);
    my $body = $cgi->param($param_body);

    $_ = $body;
    s/\n/<br>\n/g;
    my $message_html = $_;

    # Create the template object and load it.
    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_previewquotamsg.html");
    $result->TITLE("Preview Quota Message");
    $result->BACKGROUND("white");
    $result->from($from);
    $result->subject($subject);
    $result->content_type($content_type);
    $result->xmailer($xmailer);
    $result->message_text($body);
    $result->from_html(escape_html($from));
    $result->subject_html(escape_html($subject));
    $result->content_type_html(escape_html($content_type));
    $result->xmailer_html(escape_html($xmailer));
    $result->message_html($message_html);
    $result->email_ID($email_ID);
    $result->SID($SID);
    $result->output('Content-Type: text/html');
}

sub savequotamsg {
    my $file = "$db_path/999998";
    my $from = $cgi->param($param_from);
    my $subject = $cgi->param($param_subject);
    my $content_type = $cgi->param($param_content_type);
    my $xmailer = $cgi->param($param_xmailer);
    my $body = $cgi->param($param_body);

    open(MSG, ">$file") or cgierr("Unable to open the quota message($file) for
 writing.");
    print MSG "From: $from\n";
    print MSG "Subject: $subject\n";
    print MSG "Content-type: $content_type\n";
    print MSG "X-Mailer: $xmailer\n";
    print MSG "\n";
    print MSG "$body";
    close(MSG);

    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_savequotamsg.html");
    $result->TITLE("Save Quota Result");
    $result->BACKGROUND("white");
    $result->destination_url("$dir_URL/$base_url");
    $result->output('Content-Type: text/html');
}

sub sysconfig {

my $a;
my $first = 1;
my $result = "";
foreach $a (@::Admin_Users) {
  if ($first) {
    $first = 0;
  } else {
    $result .= ", ";
  }
  $result .= $a;
}


    # Create the template object and load it.
    my $setupconf = new HTMLTMPL;
    $setupconf->src("html/admin/admin_sysconfig.html");
    $setupconf->BACKGROUND("white");
    $setupconf->dir_URL("$dir_URL");
    $setupconf->db_path("$db_path");
    $setupconf->img_URL("$img_URL");
    $setupconf->Admin_Users("$result");
    $setupconf->time_off_from_eastern("$::time_off_from_eastern");
    $setupconf->POP_Server("$::POP_Server");
    $setupconf->POP_Username("$::POP_Username");
    $setupconf->POP_Pass("$::POP_Pass");
    $setupconf->smtpserver("$::smtpserver");
    $setupconf->Delete_Messages_From_Server("$::Delete_Messages_From_Server");
    $setupconf->Undeliverable_On("$::Undeliverable_On");
    $setupconf->Undeliverable_Message("$::Undeliverable_Message");
    $setupconf->Quotas("$::Quotas");
    $setupconf->Quota_Default("$::Quota_Default");
    $setupconf->Quota_Message("$::Quota_Message");
    $setupconf->Tech_Support_Email("$::Tech_Support_Email");
    $setupconf->Temp_Directory("$::Temp_Directory");
    $setupconf->Admin_Mailbox("$::Admin_Mailbox");
    $setupconf->headerad_on_all_message("$::headerad_on_all_message");
    $setupconf->headerad("$::headerad");
    $setupconf->mailad("$::mailad");
    $setupconf->email_ID($email_ID);
    $setupconf->SID($SID);
    $setupconf->msg_per_page($::msg_per_page);
    $setupconf->newuser_question01($::newuser_question01);
    $setupconf->newuser_question02($::newuser_question02);
    $setupconf->newuser_question03($::newuser_question03);
    $setupconf->newuser_question04($::newuser_question04);
    $setupconf->newuser_question05($::newuser_question05);
    $setupconf->output('Content-Type: text/html');
}

sub save_system_config {
    $::dir_URL = $cgi->param("dir_URL");
    $::db_path = $cgi->param("db_path");
    $::img_URL = $cgi->param("img_URL");

#Special processing for admin accounts required.

  my $Admin_In = $cgi->param("Admin_Users");
  foreach ($Admin_In) {
  s/^\s+//;
  }
  @::Admin_Users = split(',', $Admin_In);

    $::time_off_from_eastern = $cgi->param("time_off_from_eastern");
    $::POP_Server = $cgi->param("POP_Server");
    $::POP_Username = $cgi->param("POP_Username");
    $::POP_Pass = $cgi->param("POP_Pass");
    $::smtpserver = $cgi->param("smtpserver");
    $::Delete_Messages_From_Server = $cgi->param("Delete_Messages_From_Server");
    $::Undeliverable_On = $cgi->param("Undeliverable_On");
    $::Undeliverable_Message = $cgi->param("Undeliverable_Message");
    $::Quotas = $cgi->param("Quotas");
    $::Quota_Message = $cgi->param("Quota_Message");
    $::Quota_Default = $cgi->param("Quota_Default");
    $::Tech_Support_Email = $cgi->param("Tech_Support_Email");
    $::Temp_Directory = $cgi->param("Temp_Directory");
    $::Admin_Mailbox = $cgi->param("Admin_Mailbox");
    $::headerad_on_all_message = $cgi->param("headerad_on_all_message");
    $::headerad = $cgi->param("headerad");
    $::mailad = $cgi->param("mailad");
    $::msg_per_page = $cgi->param("msg_per_page");
    $::newuser_question01 = $cgi->param("newuser_question01");
    $::newuser_question02 = $cgi->param("newuser_question02");
    $::newuser_question03 = $cgi->param("newuser_question03");
    $::newuser_question04 = $cgi->param("newuser_question04");
    $::newuser_question05 = $cgi->param("newuser_question05");
    WriteSetupPl();
    sysconfig();
}

sub sysstyle {

    # Create the template object and load it.
    my $setupstyle = new HTMLTMPL;
    $setupstyle->src("html/admin/admin_stylesettings.html");
    $setupstyle->BACKGROUND("white");
    $setupstyle->dir_URL("$dir_URL");
    $setupstyle->comp_name("$::comp_name");
    $setupstyle->web_title("$::web_title");
    $setupstyle->web_domain("$::web_domain");
    $setupstyle->email_logo("$::email_logo");
    $setupstyle->info_color("$::info_color");
    $setupstyle->background_color("$::background_color");
    $setupstyle->toc_background_color("$::toc_background_color");
    $setupstyle->caption_color("$::caption_color");
    $setupstyle->checkbox_color("$::checkbox_color");
    $setupstyle->unread_checkbox_color("$::unread_checkbox_color");
    $setupstyle->problem_color("$::problem_color");
    $setupstyle->total_color("$::total_color");
    $setupstyle->email_ID($email_ID);
    $setupstyle->SID($SID);
    $setupstyle->output('Content-Type: text/html');

}

sub save_style_settings {
    $::comp_name = $cgi->param("comp_name");
    $::web_title = $cgi->param("web_title");
    $::web_domain = $cgi->param("web_domain");
    $::email_logo = $cgi->param("email_logo");
    $::info_color = $cgi->param("info_color");
    $::background_color = $cgi->param("background_color");
    $::toc_background_color = $cgi->param("toc_background_color");
    $::caption_color = $cgi->param("caption_color");
    $::checkbox_color = $cgi->param("checkbox_color");
    $::unread_checkbox_color = $cgi->param("unread_checkbox_color");
    $::problem_color = $cgi->param("problem_color");
    $::total_color = $cgi->param("total_color");

    WriteSetupPl();
    sysstyle();
}

sub showcolors {
    # Create the template object and load it.
    my $setshowcolors = new HTMLTMPL;
    $setshowcolors->src("html/admin/admin_colors.html");
    $setshowcolors->output('Content-Type: text/html');

}

sub userinfo {

my $a;
my $first = 1;

my $showuser = $cgi->param($param_user_name);
my %User_info;
my $F_name;
my $L_name;
my $T_zone;
my $City;
my $State;
my $ZipCode;
my $xgender;
my $birth_month;
my $birth_day;
my $birth_year;
my $popuser;
my $popserver;
my $quota_limit;
my $newuser_answer01;
my $newuser_answer02;
my $newuser_answer03;
my $newuser_answer04;
my $newuser_answer05;
my $newuser_question01;
my $newuser_question02;
my $newuser_question03;
my $newuser_question04;
my $newuser_question05;
my $Aliases;

dbmopen(%User_info,"$db_path/$showuser/user_info",0660) || die "Could not open $db_path/$showuser/user_info.db $!";

$F_name = $User_info{'00F_name'};
$L_name = $User_info{'01L_name'};
$T_zone = $User_info{'TZone'};
$City = $User_info{'10City'};
$State = $User_info{'11State'};
$ZipCode = $User_info{'12ZipCode'};
$xgender = $User_info{'13xgender'};
$birth_month = $User_info{'14birth_month'};
$birth_day = $User_info{'15birth_day'};
$birth_year = $User_info{'16birth_year'};
$popuser = $User_info{'01POP_user'};
$popserver = $User_info{'00POP_server'};
$quota_limit = $User_info{'17Quota_limit'};
$newuser_question01 = $::newuser_question01;
$newuser_question02 = $::newuser_question02;
$newuser_question03 = $::newuser_question03;
$newuser_question04 = $::newuser_question04;
$newuser_question05 = $::newuser_question05;
$newuser_answer01 = $User_info{'22AddQues01'};
$newuser_answer02 = $User_info{'22AddQues02'};
$newuser_answer03 = $User_info{'22AddQues03'};
$newuser_answer04 = $User_info{'22AddQues04'};
$newuser_answer05 = $User_info{'22AddQues05'};
$Aliases = $User_info{'18Aliases'};

if ($quota_limit < 1) {
$quota_limit = $::Quota_Default;
}

my $dir_size;
my $QPercent;
my $QPcolor;

($dir_size, $QPercent) = &Check_quota($quota_limit,$showuser);
$QPcolor = "black";
if ($QPercent > 100) {
$QPcolor = "red";
}
$dir_size .= " kb";
$QPercent .= " %";
$quota_limit .= " kb";

   # Create the template object and load it.
    my $showuserinfo = new HTMLTMPL;
    $showuserinfo->src("html/admin/admin_userinfo.html");
    $showuserinfo->BACKGROUND("white");
    $showuserinfo->firstname("$F_name");
    $showuserinfo->lastname("$L_name");
    $showuserinfo->zone("$T_zone");
    $showuserinfo->city("$City");
    $showuserinfo->state("$State");
    $showuserinfo->zip("$ZipCode");
    $showuserinfo->gender("$xgender");
    $showuserinfo->bmonth("$birth_month");
    $showuserinfo->bday("$birth_day");
    $showuserinfo->byear("$birth_year");
    $showuserinfo->popuser("$popuser");
    $showuserinfo->popserver("$popserver");
    $showuserinfo->default_quota("$::Quota_Default");
    $showuserinfo->qmax("$quota_limit");
    $showuserinfo->qused("$dir_size");
    $showuserinfo->qpercent("$QPercent");
    $showuserinfo->qpcolor("$QPcolor");
    $showuserinfo->newuser_question01("$::newuser_question01");
    $showuserinfo->newuser_question02("$::newuser_question02");
    $showuserinfo->newuser_question03("$::newuser_question03");
    $showuserinfo->newuser_question04("$::newuser_question04");
    $showuserinfo->newuser_question05("$::newuser_question05");
    $showuserinfo->newuser_answer01("$newuser_answer01");
    $showuserinfo->newuser_answer02("$newuser_answer02");
    $showuserinfo->newuser_answer03("$newuser_answer03");
    $showuserinfo->newuser_answer04("$newuser_answer04");
    $showuserinfo->newuser_answer05("$newuser_answer05");
#    $showuserinfo->alias_list("$Aliases");
    $showuserinfo->dir_URL("$dir_URL");
    $showuserinfo->db_path("$db_path");
    $showuserinfo->email_ID($email_ID);
    $showuserinfo->SID($SID);
    $showuserinfo->username($showuser);
    $showuserinfo->output('Content-Type: text/html');

dbmclose %User_info || die "Could not close HASH. $!";

}

sub userinfo_updatequota {
    my $user = $cgi->param($param_user_name);
    my $newQuotaIn = $cgi->param($param_new_quota);
    my $newQuota = int($newQuotaIn);
    my %User_info;

    if ($newQuota > 0) {
        dbmopen(%User_info,"$db_path/$user/user_info",0660) ||
                die "Could not open $db_path/$user/user_info.db $!";

        $User_info{'17Quota_limit'} = "$newQuota";

        dbmclose %User_info || die "Could not close HASH. $!";
    }

    userinfo();
}

sub userinfo_changepassword {
    my $user = $cgi->param($param_user_name);
    my $newPassword = $cgi->param($param_new_password);

    open (PASSWORD, ">$db_path/$user/pass") || die "Could not open $db_path/$user/pass for writing.  $!";
    print PASSWORD (crypt($newPassword, 'culy'));
    close PASSWORD;

    userinfo();
}

sub editaliases {

my %Aliases;
my $alias01;
my $routeto01;
my $alias02;
my $routeto02;
my @ListOfKeys;
my $Key;
my $i = 0;

dbmopen(%Aliases,"$db_path/alias_info",0660) || die "Could not open $
db_path/alias_info db $!";

@ListOfKeys = sort keys %Aliases;

    # Create the template object and load it.
    my $result = new HTMLTMPL;
    $result->src("html/admin/admin_editaliases.html");
    $result->BACKGROUND("white");

foreach $Key (@ListOfKeys) {
$result->Alias($Key, 'x_aliases');
$result->AliasNo($i, 'x_aliases');
$result->RouteTo($Aliases{$Key}, 'x_aliases');
++$i;
}

my $count;
for ($count=1; $count<6; $count++)
{
$result->Alias('', 'x_aliases');
$result->AliasNo($i, 'x_aliases');
$result->RouteTo('', 'x_aliases');
++$i;
}

    $result->email_ID($email_ID);
    $result->SID($SID);
    $result->output('Content-Type: text/html');

dbmclose %Aliases || die "Could not close HASH. $!";

}

sub savealiases {
    my %Aliases;
    my $counter = 0;
    my $alias;
    my $routeTo;

    dbmopen(%Aliases,"$db_path/alias_info",0660) || die "Could not open $
    db_path/alias_info db $!";

    $alias = $cgi->param("Alias$counter");
    while ($alias) {
	$routeTo = $cgi->param("RouteTo$counter");
	$Aliases{$alias} = $routeTo;

	$counter++;
	$alias = $cgi->param("Alias$counter");
    }

    dbmclose %Aliases || die "Could not close HASH. $!";

    editaliases();
}

sub deletealiases {
    my %Aliases;
    my $counter = 0;
    my $delete;
    my $alias;
    my @deletealiases = $cgi->param($param_user_name);

    dbmopen(%Aliases,"$db_path/alias_info",0660) || die "Could not open $db_path/alias_info db $!";

    foreach my $a (@deletealiases) {
	delete ($Aliases{$a});
    }

    dbmclose %Aliases || die "Could not close HASH. $!";

    editaliases();
}

sub EscapePerlString {
  my ($copy) = @_;
  $copy =~ s/\'/\\\'/g;
  return $copy;
}

sub WriteSetupPl {
  rename("setup.pl", "setup.pl.orig") || die "Cannot backup setup.pl.  $!";
  open(FD, "> setup.pl") || die "Cannot open setup.pl for writing.  $!";
  print FD <<EOP;
# @{[EscapePerlString($::setup_pl_version_information)]}
#
# WARNING:
# If you add variables to this file, admin.cgi's WriteSetupPl subroutine
# must be updated as well.

# The current version of this file.  Required to be able to regenerate the
# file after the user makes changes.
\$setup_pl_version_information = \'@{[EscapePerlString($::setup_pl_version_information)]}\';

##  Company Name
\$comp_name = \'@{[EscapePerlString($::comp_name)]}\';

##  Web Page Titles
##  Displayed at the top of the web browser.
\$web_title = \'@{[EscapePerlString($::web_title)]}\';

##  Free E-mail domain name
##  Displayed on the "New User" signup screen.
\$web_domain = \'@{[EscapePerlString($::web_domain)]}\';

##  Company Image file
##  e.g., "/images/culymail/logo.gif"
\$email_logo = \'@{[EscapePerlString($::email_logo)]}\';

##  Info Text Color
##  Color of informational text
##  (e.g., Your session has expired, please log back in...)
\$info_color = \'@{[EscapePerlString($::info_color)]}\';

##  Main Background Color
##  Background color for all pages displayed in the MAIN window frame.
\$background_color=\'@{[EscapePerlString($::background_color)]}\';

##  TOC Background Color
##  Background color for all pages displayed in the TOC window frame.
\$toc_background_color=\'@{[EscapePerlString($::toc_background_color)]}\';

##  Caption Text Color
\$caption_color = \'@{[EscapePerlString($::caption_color)]}\';

##  Checkbox Color (Used in pop.cgi)
##  Color of the table cell with the checkbox in it, when the message
##  has been read.
\$checkbox_color = \'@{[EscapePerlString($::checkbox_color)]}\';

##  Checkbox Color (Used in pop.cgi)
##  Color of the table cell with the checkbox in it, when the message
##  has not been read yet.
\$unread_checkbox_color = \'@{[EscapePerlString($::unread_checkbox_color)]}\';

##  Problem Text Color
##  The color of the text when there is a problem.
##  (e.g., Password must be at least 5 characters)
\$problem_color = \'@{[EscapePerlString($::problem_color)]}\';

##  Totals Color (Used in folder.cgi...)
##  Table cell color for the Total folder sizes when you click on "Folders"
\$total_color = \'@{[EscapePerlString($::total_color)]}\';

##  POP_Server - The name of the server to access for distributing mail
\$POP_Server = \'@{[EscapePerlString($::POP_Server)]}\';

##  POP_Username - The name of the user with which to log into the POP server
\$POP_Username = \'@{[EscapePerlString($::POP_Username)]}\';

##  POP_Pass - The password used to access the POP_Username account.
\$POP_Pass = \'@{[EscapePerlString($::POP_Pass)]}\';

##  Default SMTP server for sending mail.
\$smtpserver = \'@{[EscapePerlString($::smtpserver)]}\';

##  Delete_Messages_From_Server -
##    0 = leave the messages on the server
##    1 = Delete the messages
\$Delete_Messages_From_Server = $::Delete_Messages_From_Server;

##  Quota on/off
##    1 = on
##    0 = off
\$Quotas = $::Quotas;

##  Message to send if Quotas are turned on and their mailbox if full.
\$Quota_Message = \'@{[EscapePerlString($::Quota_Message)]}\';

##  Default Quota limit size. (This can be edited in the user editor).
\$Quota_Default = $::Quota_Default;

##  Tech_Support_Email - The email address of the person to email when something goes wrong.
\$Tech_Support_Email = \'@{[EscapePerlString($::Tech_Support_Email)]}\';

##  Temp_Directory - A place where the message is written initially.  Once processing is complete, it is moved to the user's directory.
\$Temp_Directory = \'@{[EscapePerlString($::Temp_Directory)]}\';

##  Admin_Mailbox - Place to store mail when the to address is not recognized.
\$Admin_Mailbox = \'@{[EscapePerlString($::Admin_Mailbox)]}\';

##  Send undeliverable message back if account not found
##    0 = no
##    1 = yes
\$Undeliverable_On = $::Undeliverable_On;

##  Message to send back if Undelviverable_On = 1.
\$Undeliverable_Message = \'@{[EscapePerlString($::Undeliverable_Message)]}\';

\$headerad_on_all_message = $::headerad_on_all_message;
##  headerad - Lines added to the top of every page displayed
\$headerad = \'\n@{[EscapePerlString($::headerad)]}\';

##  mailad - Lines added to the end of every e-mail sent
\$mailad = \'\n@{[EscapePerlString($::mailad)]}\';

##  Path to the culymail cgi-bin directory.
\$dir_URL = \'@{[EscapePerlString($::dir_URL)]}\';

##  Path to the mail database.
\$db_path = \'@{[EscapePerlString($::db_path)]}\';

##  Path to the images
\$img_URL = \'@{[EscapePerlString($::img_URL)]}\';

##  The amount of time (in seconds) until the session expires.
\$time_til_expire = @{[EscapePerlString($::time_til_expire)]};

##  This is the number of seconds that the server running culymail is behind
##  the Eastern Timezone in the United States.  For example, if the server
##  is in the Central timezone, then this value should be 3600.
\$time_off_from_eastern = @{[EscapePerlString($::time_off_from_eastern)]};

##  Number of messages to display on each page.
\$msg_per_page = @{[EscapePerlString($::msg_per_page)]};

## 5 Additional Questions for New Users:
\$newuser_question01 = \'@{[EscapePerlString($::newuser_question01)]}\';
\$newuser_question02 = \'@{[EscapePerlString($::newuser_question02)]}\';
\$newuser_question03 = \'@{[EscapePerlString($::newuser_question03)]}\';
\$newuser_question04 = \'@{[EscapePerlString($::newuser_question04)]}\';
\$newuser_question05 = \'@{[EscapePerlString($::newuser_question05)]}\';

##Admin_Users = Account names of users that will have access to the Admin Utilities.
EOP

print FD "\@Admin_Users = (";
my $first = 1;
foreach my $user (@::Admin_Users) {
  if ($first) {
    $first = 0;
  } else {
    print FD ", ";
  }
  print FD "\'@{[EscapePerlString($user)]}\'"
}
print FD ");\n";

print FD <<EOP;

1;
EOP

close(FD);
}

# Helping functions.

sub cgierr {
# --------------------------------------------------------
# Displays any errors and prints out FORM and ENVIRONMENT
# information. Useful for debugging.
#
    my $in;
    eval { $in = new GT::CGI; };
    if (defined $GT::CGI::PRINTED_HEAD) {
        print "Content-type: text/html\n\n" unless ($GT::CGI::PRINTED_HEAD);
    } else {
        print "Content-type: text/html\n\n";
    }

    my ($key, $env);
    my ($error, $nolog) = @_;
    print "</td></tr></table>";
    print "</td></tr></table></center></center>";
    print "<PRE>\n\nDEBUG\n=======================================\n";
    $error    and print "Error Message       : $error\n";
    $0        and print "Script Location     : $0\n";
    $]        and print "Perl Version        : $]\n";

    print "\nEnvironment Variables\n----------------------------------------\n";
    foreach $env (sort keys %ENV) {
        my $space = " " x (20 - length($env));
        print "$env$space: $ENV{$env}\n";
    }
    print "\nStack Trace \n----------------------------------------\n";
    my $i = 0;
    while (my ($file, $line, $sub) = (caller($i++))[1,2,3]) {
        print qq!($sub) called from ($file) line ($line)<BR>\n!;
    }
    print "\n</PRE>";
    exit;
}
